:- module(snode,[
                ]).

%snode: snode(Score,PTree)

init(Score,PTree,snode(Score,PTree)).

get_ptree(snode(_,PTree),PTree).

get_score(snode(Score,_),Score).

rescore([],[]):-!.

rescore([PTree|PTrees],[SNode|SNodes]):-
    score(PTree,Score),
    snode:init(Score,PTree,SNode),
    rescore(PTrees,SNodes).

score(PTree,Score):-
    ptree:get_subst(PTree,SubstList),
    length(SubstList,Score).

merge_list(SNodes,[],SNodes):- !.

merge_list([SNode_1|SNodes_1],[SNode_2|SNodes_2],[SNode_1|SNodes_new]):-
    get_score(SNode_1,Score_1),
    get_score(SNode_2,Score_2),
    Score_1  < Score_2, !,
    merge(SNodes_1,[SNode_2|SNodes_2],SNodes_new).

merge_list(SNodes_1,[SNode_2|SNodes_2],[SNode_2|SNodes_new]):-
    %Score_1 =< Score_2, !,
    merge(SNodes_1,SNodes_2,SNodes_new).
    
print(SNode):-
    snode:get_score(SNode,Score),
    snode:get_ptree(SNode,PTree),
    ptree:get_goal(PTree,Goal),
    ptree:get_root(PTree,Root),
    ptree:get_subst(PTree,Subst),
    ptree:get_codtree(PTree,CodTree),
    codtree:simplify_tree(CodTree,SimpleTree),
    writef('Order:  %t',[Score]),nl,
    writef('Goal :  %t',[Goal]),nl,
    writef('Root :  %t',[Root]),nl,
    writef('Tree :  %t',[SimpleTree]),nl,
    writef('Subst:  %t',[Subst]),nl.