:- module(utils,[
                    all/2,
                    any/2,
                    smember/2
                ]).

:- module_transparent any/2,
                      all/2,
                      smember/2.

any(Goal,[Head|_Tail]):-
    call(Goal,Head),!.

any(Goal,[_Head|Tail]):-
    all(Goal,Tail).    

all(_Goal,[]).

all(Goal,[Head|Tail]):-
    call(Goal,Head),
    all(Goal,Tail).    
    
smember(Elem,[Head|_]):-
    Elem == Head.
    
smember(Elem,[_|Tail]):-
    smember(Elem,Tail).